package gamma;

import gammaSupport.Connector;

/** ArrayCrossBar is an nxn array of constructors that split and then merge */
public class ArrayCrossBar implements gammaSupport.GammaConstants {
    
    /** 
     * creates an array crossbar over joinkey
     * @param in -- array of input connectors
     * @param out -- array of output connectors
     * @param joinkey -- join key on which to split and merge
     */
    public ArrayCrossBar( Connector[] in, Connector[] out, String joinkey) {
        Connector[][] cb = Connector.newConnectorMatrix("cb"+in[0].getName() + ":"+ out[0].getName());
        Connector[][] xcb = Connector.transpose(cb);
        
        for (int i=0; i<splitLen; i++) new HSplit(in[i],cb[i], joinkey);
        for (int j=0; j<splitLen; j++) new Merge(xcb[j], out[j]);
    }
}
